
 
clear all
 ii_c_max=5;
for ii_c=1:ii_c_max
    
    

 data_exact=[];
 data_p=[];
 data_grad_exact=[];
 data_grad_app=[];
 data_Sp1=[];
 
 data_Se=[];
 data_asymp=[];
 data_corr=[];
 dd=[];
 NNN=300;
 dist=[0.001 0.01 0.1 1 10]*1;
 nn_list=[1500 500 200 200 70 ];
for pp=1:NNN
    
Radius=30;
distance=dist(ii_c);
alp=sqrt(distance*(4*Radius+distance))/2;
s=asinh(alp/Radius);
 n = nn_list(ii_c);


w=linspace(0.01,5.0,NNN);
w0=8.7112;
g0=0.0046;

drude = 1- w0^2/(w(pp)*(w(pp)+1i*w0*g0));
f(1)=18.0701; wv(1)=3.2821; g(1)=5.5623; gt(1)=-0.3185;
f(2)=-0.0470; wv(2)=4.0485; g(2)=0.1436; gt(2)=-0.3639;
f(3)=-4.7770; wv(3)=5.4592; g(3)=36.9163;gt(3)=26.0448;
f(4)=5.0125;  wv(4)=5.8467; g(4)=0.9918; gt(4)=-0.7438;
f(5)=-1.3280; wv(5)=8.6878; g(5)=1.1054; gt(5)=-3.1086;
f(6)=-11.4240;wv(6)=16.0805;g(6)=18.9124;gt(6)=-7.3710;

FF=0;
for j=1:6
FF=FF+(f(j)*wv(j)^2+1i*gt(j)*wv(j)*w(pp))/(w(pp)^2-wv(j)^2+1i*g(j)*wv(j)*w(pp));
end
drude=drude-FF;
epep=1/drude;


 tau=(1/epep-1)/(1/epep+1);
 er=1/epep;
 taustar=er*(er-1)/(er+1)^2;
 
 taustar=tau;
 taustartemp=tau;
 %taustartemp=taustar;
 
 

 a = ones(n,1);
 b = ones(n,1); 
 c = ones(n,1);
 
 f = ones(n,1);
 %%%%%%%%%%%%%%
 %%% exact
 for i=1:n
     j=i-1;
     
     a(i) = 1*(-1)*((2*j+1)*cosh(s)*(epep*(0+1*cosh((j+1/2)*s))+sinh((j+1/2)*s))+1*(1*epep-1)*sinh(s)*sinh((j+1/2)*s));
     b(i) = 1*(j)*(epep*cosh((j-1/2)*s)+sinh((j-1/2)*s));
     c(i) = 1*(j+1)*(epep*cosh((j+3/2)*s)+sinh((j+3/2)*s));
     
     f(i) = 2^(3/2)*alp*(epep-1)*exp(-(j+1/2)*s)*((j)*exp(s)-(j+1)*exp(-s));
 end
 y = tridiag(a,b,c,f);
 summ=0;
 grad=0;
 sum_check=0;
 for i=1:n
     j=i-1;
     
     summ=summ+y(i)*(j+1/2);
     grad=grad+1/s*y(i)*(j+1/2)*(-1)^i;
 end
 p0=2*tau/(3-tau)*Radius^3;
 ss=-log(tau)/2/s;

%%% exact_polarizability
Exact=summ*alp^2*2^(3/2)/1;
%%%

% sumexp*alp^2*2^(3/2)/2;
%asymp= (zeta(3)*2+pi^4/36/(log(2*s)+psicpx(ss+1/2)))*p0;

grad_exact=1;

 for i=1:n
     j=i-1;
     t=(i-1*1/2)*s;
     
     grad_exact=grad_exact-2^(3/2)/alp*y(i)*(j+1/2)*(-1)^j;
    
 end
 
 Sp1=0;
 Sp2=0;
 for i=1:n
     j=i-1;
      Sp1=Sp1+1/(exp((2*j+1)*s)-tau);
      Sp2=Sp2+(2*j+1)/(exp((2*j+1)*s)-tau);
     % Sp3=Sp3+(2*j+1)^2/(exp((2*j+1)*s)-tau);
 end

 %%%%%
 coeff_A=zeros(1,n);
 summ_A=0;
 S0=Sp2/Sp1;
 grad_A=1;
 for i=1:n
     j=i-1;
     coeff_A(i)=2^(5/2)*tau*alp/(3-tau)*(  1*(2*j+1)-1*S0)/(exp((2*j+1)*s)-tau);
     coeff_A(i)=coeff_A(i)*(1-0/drude);
     summ_A=summ_A+coeff_A(i)*(j+1/2);
     grad_A=grad_A-2^(3/2)/alp*coeff_A(i)*(j+1/2)*(-1)^j;
 end
 
 p=summ_A*alp^2*2^(3/2)/1;
 %%%%%
 
RR=Radius;
data_exact=[ data_exact  Exact*w(pp)*1/RR^3/(4*pi)];
data_p=[ data_p p*w(pp)*1/RR^3/(4*pi)];
 %data_Sp1=[data_Sp1 1/Sp1];
data_grad_exact=[ data_grad_exact  grad_exact];
data_grad_app=[ data_grad_app 1*grad_A];
 
end

C = linspecer(ii_c_max);

%

figure(1)
y1=imag(data_exact*1);
y2=imag(data_p*1);

%ttt=plot(w,log10(y1),'color',C(1,:),w,log10(y2),'r');
semilogy(w,real((y1)),'--','color',C(ii_c,:),'linewidth',2.5);
hold on
semilogy(w,real((y2)),'color',C(ii_c,:),'linewidth',2.5);
hold on
%ttt2=plot(w,log10(y2),'color',C(1,:));
%set(ttt,'LineWidth',2);
%set(ttt2,'LineWidth',1.5);
axis([0.1,4.2,10^(-5),10^(1.0)]);
set(gca,'fontsize',17)

figure(2)
yy1=abs(data_grad_exact);
yy2=abs(data_grad_app);
%yy_test=abs(data_Sp1);
%m1 = max(yy_test(:));
%yy_test = yy_test / m1*10^5;
%[mm,ii]=max(yy1)

semilogy(w,real((yy1)),'--','color',C(ii_c,:),'linewidth',2.5);
hold on
semilogy(w,real((yy2)),'color',C(ii_c,:),'linewidth',2.5);
hold on
%plot(w,real(log10(yy_test)),'r','linewidth',1.5);

axis([0.1,4.2,10^(-0.5),10^(7.5)]);
set(gca,'fontsize',17)
%hold off

% figure(5)
% yyy1=abs(data_grad_exact);
% yyy2=abs(data_grad_app);
% %yy_test=abs(data_Sp1);
% %m1 = max(yy_test(:));
% %yy_test = yy_test / m1*10^5;
% [mm,ii]=max(yyy1);
% w(ii)
% 
% plot(w,real((yy1)),'-','color',C(ii_c,:),'linewidth',2.5);
% hold on
% %plot(w,real((yy2)),'color',C(ii_c,:),'linewidth',2.5);
% %hold on
% %plot(w,real(log10(yy_test)),'r','linewidth',1.5);
% 
% axis([1.0,3.5,0,40500]);
% set(gca,'fontsize',12)
% %hold off

end
%
figure(2)

title('Field enhancement')
xlabel('Frequency (eV)') % x-axis label
ylabel('|E/E_0|') % y-axis label


% legend('\delta=0.001','', ...
% '\delta=0.01','',...
% '\delta=0.1','',...
% '\delta=1','',...
% '\delta=10','')
set(gca,'fontsize',17)
lll=0.37;ld=0.52;sl=4.55;sslla=2.9-0.5+0.1+0.08;sslle=3.5-0.5+0.1;
hold on
th = 0:1:1;xunit = sslla+lll*th;zunit = ones(1,size(th,2))*10^(sl);
plot(xunit, zunit,'color',C(5,:),'linewidth',2.5); hold on
th = 0:1:1;xunit = sslla+lll*th;zunit = ones(1,size(th,2))*10^(sl+ld);
plot(xunit, zunit,'color',C(4,:),'linewidth',2.5); hold on
th = 0:1:1;xunit = sslla+lll*th;zunit = ones(1,size(th,2))*10^(sl+ld*2);
plot(xunit, zunit,'color',C(3,:),'linewidth',2.5); hold on
th = 0:1:1;xunit = sslla+lll*th;zunit = ones(1,size(th,2))*10^(sl+ld*3);
plot(xunit, zunit,'color',C(2,:),'linewidth',2.5); hold on
th = 0:1:1;xunit = sslla+lll*th;zunit = ones(1,size(th,2))*10^(sl+ld*4);
plot(xunit, zunit,'color',C(1,:),'linewidth',2.5); hold on

th = 0:1:1;xunit = sslle+lll*th;zunit = ones(1,size(th,2))*10^(sl);
plot(xunit, zunit,'--','color',C(5,:),'linewidth',2.5); hold on
th = 0:1:1;xunit = sslle+lll*th;zunit = ones(1,size(th,2))*10^(sl+ld);
plot(xunit, zunit,'--','color',C(4,:),'linewidth',2.5); hold on
th = 0:1:1;xunit = sslle+lll*th;zunit = ones(1,size(th,2))*10^(sl+ld*2);
plot(xunit, zunit,'--','color',C(3,:),'linewidth',2.5); hold on
th = 0:1:1;xunit = sslle+lll*th;zunit = ones(1,size(th,2))*10^(sl+ld*3);
plot(xunit, zunit,'--','color',C(2,:),'linewidth',2.5); hold on
th = 0:1:1;xunit = sslle+lll*th;zunit = ones(1,size(th,2))*10^(sl+ld*4);
plot(xunit, zunit,'--','color',C(1,:),'linewidth',2.5); hold on

text(0.665-0.115+0.035,0.95,'approx.','Units','normalized','fontsize',17)
text(0.825-0.115+0.02,0.95,'exact','Units','normalized','fontsize',17)

tx1=0.02+0.01;
td=0.065;ty0=0.62+0.01;
text(0.815+tx1,ty0,'\delta=10','Units','normalized','fontsize',17)
text(0.815+tx1,ty0+td,'\delta=1','Units','normalized','fontsize',17)
text(0.815+tx1,ty0+td*2,'\delta=0.1','Units','normalized','fontsize',17)
text(0.815+tx1,ty0+td*3,'\delta=0.01','Units','normalized','fontsize',17)
text(0.815+tx1,ty0+td*4,'\delta=0.001','Units','normalized','fontsize',17)


text(-0.15,1.05,'a','Units','normalized','fontsize',25,'fontweight','bold')


hold off 

figure(1)

title('Absorption cross section')
xlabel('Frequency (eV)') % x-axis label
ylabel('\sigma_a/4\pi R^3') % y-axis label

% legend('\delta=0.001','', ...
% '\delta=0.01','',...
% '\delta=0.1','',...
% '\delta=1','',...
% '\delta=10','','location','southeast')
set(gca,'fontsize',17)
lll=0.37;ld=0.35;sl=-4.5;sslla=2.9-0.5-0.1;sslle=3.5-0.5-0.1;
hold on
th = 0:1:1;xunit = sslla+lll*th;zunit = ones(1,size(th,2))*10^(sl);
plot(xunit, zunit,'color',C(5,:),'linewidth',2.5); hold on
th = 0:1:1;xunit = sslla+lll*th;zunit = ones(1,size(th,2))*10^(sl+ld);
plot(xunit, zunit,'color',C(4,:),'linewidth',2.5); hold on
th = 0:1:1;xunit = sslla+lll*th;zunit = ones(1,size(th,2))*10^(sl+ld*2);
plot(xunit, zunit,'color',C(3,:),'linewidth',2.5); hold on
th = 0:1:1;xunit = sslla+lll*th;zunit = ones(1,size(th,2))*10^(sl+ld*3);
plot(xunit, zunit,'color',C(2,:),'linewidth',2.5); hold on
th = 0:1:1;xunit = sslla+lll*th;zunit = ones(1,size(th,2))*10^(sl+ld*4);
plot(xunit, zunit,'color',C(1,:),'linewidth',2.5); hold on

th = 0:1:1;xunit = sslle+lll*th;zunit = ones(1,size(th,2))*10^(sl);
plot(xunit, zunit,'--','color',C(5,:),'linewidth',2.5); hold on
th = 0:1:1;xunit = sslle+lll*th;zunit = ones(1,size(th,2))*10^(sl+ld);
plot(xunit, zunit,'--','color',C(4,:),'linewidth',2.5); hold on
th = 0:1:1;xunit = sslle+lll*th;zunit = ones(1,size(th,2))*10^(sl+ld*2);
plot(xunit, zunit,'--','color',C(3,:),'linewidth',2.5); hold on
th = 0:1:1;xunit = sslle+lll*th;zunit = ones(1,size(th,2))*10^(sl+ld*3);
plot(xunit, zunit,'--','color',C(2,:),'linewidth',2.5); hold on
th = 0:1:1;xunit = sslle+lll*th;zunit = ones(1,size(th,2))*10^(sl+ld*4);
plot(xunit, zunit,'--','color',C(1,:),'linewidth',2.5); hold on

text(-0.15,1.05,'b','Units','normalized','fontsize',25,'fontweight','bold')
text(0.665-0.145,0.38,'approx.','Units','normalized','fontsize',17)
text(0.825-0.145,0.38,'exact','Units','normalized','fontsize',17)


td=0.060;
text(0.815,0.08,'\delta=10','Units','normalized','fontsize',17)
text(0.815,0.08+td,'\delta=1','Units','normalized','fontsize',17)
text(0.815,0.08+td*2,'\delta=0.1','Units','normalized','fontsize',17)
text(0.815,0.08+td*3,'\delta=0.01','Units','normalized','fontsize',17)
text(0.815,0.08+td*4,'\delta=0.001','Units','normalized','fontsize',17)



hold off



%saveTightFigure(figure(1),'absorption_freq.pdf');
%saveTightFigure(figure(2),'field_enhancement_freq.pdf');
