clear all

Radius=1;
distance=0.025;
E0=1;
alp=sqrt(distance*(4*Radius+distance))/2;
s=asinh(alp/Radius);


J=3;
theta_star = pi/180*30;%-pi/6

beta=pi/180*80;
gam=beta/2;



 p=10; 
 N_TO= 120;
%%% SAVED : (p,N_TO) = (2, 150), (5,150), (10,250), (20,350) -> NNN: 151
                        %(30, 650) -> NNN: 101

%%%%% glmn data
g_data_p=zeros(p^2+2*p,N_TO);
g_data_m=zeros(p^2+2*p,N_TO);
for l=1:p
    for m=-l:l
        for n=abs(m):N_TO+abs(m)-1 
            g_data_p(l^2+l+m,n-abs(m)+1) = glmn(1,alp,l,m,n);
            g_data_m(l^2+l+m,n-abs(m)+1) = glmn(-1,alp,l,m,n);
        end
    end
end
%save g_data_p
%save g_data_m
save('g_data_p.mat', 'g_data_p');
save('g_data_m.mat', 'g_data_m');

%%%%%%%%%%%%%%%%%%%
DL_data = DLnm3(p,N_TO,s,alp);
%save DL_data
save('DL_data.mat', 'DL_data');

%%%%%%%%%%%%%%%%%%%%



NNN=51;
w=linspace(1,3.5,NNN);    

%NNN=1;
%w=1.3;    


   
%%
 MatRbeta_O = gen_MatR(p,beta);
12.1
    MatRgam_O = gen_MatR(p,gam);
12.2
    MatRbetgam_O = gen_MatR(p,-beta+gam);
12.3
  %  MatBigRbeta_O = [MatRbeta, MatZero; MatZero, MatRbeta];
12.4;
    
    [MatMmp12_O, MatMpm12_O] = gen_MatM(p,2*Radius+distance);
12.5
    [MatMmp13_O, MatMpm13_O] = gen_MatM(p,(2*Radius+distance)*cos(gam)*2 );
12.6
    MatMmp23_O = MatMmp12_O;
12.7
    MatMpm23_O = MatMpm12_O;
12.8
 
   %%
    % MatBdataP5N150W1
    % MatBdataP10N250W1
    % MatBdataP20N350W1
    % MatBdataP30N650W1
num_ind_p=1;
%p_list = [5,10,20,30];
%N_TO_list = [150,250,350,650];
p_list = [p,10,20,30];
N_TO_list = [N_TO,250,350,650];


for njn=1:num_ind_p
        
        
    p=p_list(njn);    
    N_TO = N_TO_list(njn);
    
    coeff_data=[];
    electric_field_data =[];
    for ii=1:NNN

1
        
        er=drude_silver(w(ii));
        tau=(er-1)/(er+1);
        %%%%% neutral charge data %%%%%
         Q=zeros(2,p);
         for a=1:p
         Q(:,a) = constQl(N_TO,a,s,alp,tau, g_data_p, DL_data);
         end
         save Q
         %clear Q;
         %load(['MatBdata/' 'newQdataP' num2str(p) 'N' num2str(N_TO) 'W' num2str(ii) '.mat'], 'Q');
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
1212
          MatA0 = gen_matA(p,er,Radius);
    MatZero = zeros(p^2+2*p);
    MatA= [MatA0, MatZero, MatZero ; MatZero, MatA0, MatZero ; MatZero, MatZero, MatA0];
12
    PP=p^2+2*p; 


    MatRbeta = MatRbeta_O(1:PP,1:PP);
12.1
    MatRgam = MatRgam_O(1:PP,1:PP);
12.2
    MatRbetgam = MatRbetgam_O(1:PP,1:PP);
12.3
    MatBigRbeta = [MatRbeta, MatZero; MatZero, MatRbeta];
12.4
    
    %[MatMmp12, MatMpm12] = gen_MatM(p,2*Radius+distance);
    MatMmp12 = MatMmp12_O(1:PP,1:PP);
    MatMpm12 = MatMpm12_O(1:PP,1:PP);
12.5
    %[MatMmp13, MatMpm13] = gen_MatM(p,(2*Radius+distance)*cos(gam)*2 );
    MatMmp13 = MatMmp13_O(1:PP,1:PP);
    MatMpm13 = MatMpm13_O(1:PP,1:PP);
    MatMmp23 = MatMmp23_O(1:PP,1:PP);
    MatMpm23 = MatMpm23_O(1:PP,1:PP);

12.8;
    %%%%%%%%%% choice 1
        [MatTC, MatTD] = gen_matBD_new2(p, s, alp, tau, N_TO);
        
        
   %%%%%%%%%%% choice 2     
        %load(['MatBdata/' 'newMatBdataP' num2str(p) 'N' num2str(N_TO) 'W' num2str(ii) '.mat'], 'MatB');
        %oad(['MatBdata/' 'newMatDdataP' num2str(p) 'N' num2str(N_TO) 'W' num2str(ii) '.mat'], 'MatD');
        %MatTC=MatB;
        %MatTD=MatD;
        
        MatTCmm = MatTC(1:PP,1:PP);MatTCmp = MatTC(1:PP,PP+1:2*PP);
        MatTCpm = MatTC(PP+1:2*PP,1:PP);MatTCpp = MatTC(PP+1:2*PP,PP+1:2*PP);

3
        MatRTCR_beta = MatBigRbeta' * MatTC * MatBigRbeta;  
        MatRTDR_beta = MatBigRbeta' * MatTD * MatBigRbeta;

4

        MatC=zeros(PP*J);
        MatC(1:2*PP,1:2*PP) = MatTC;
        MatC(PP+1:3*PP,PP+1:3*PP) = MatC(PP+1:3*PP,PP+1:3*PP) + MatRTCR_beta;
        MatC(PP+1:2*PP,PP+1:2*PP) = MatC(PP+1:2*PP,PP+1:2*PP) - eye(PP);


        MatD=zeros(PP*J);
        MatD(1:2*PP,1:2*PP) = MatTD;
        MatD(PP+1:3*PP,PP+1:3*PP) = MatD(PP+1:3*PP,PP+1:3*PP) + MatRTDR_beta;


        MatD(1:PP, PP+1:2*PP) = MatD(1:PP, PP+1:2*PP) + MatMmp12*MatRbeta'*MatTCmm*MatRbeta + MatRgam'*MatMmp13*MatRbetgam*MatTCpm*MatRbeta - MatMmp12;
        MatD(1:PP, 2*PP+1:3*PP) = MatD(1:PP, 2*PP+1:3*PP) + MatMmp12*MatRbeta'*MatTCmp*MatRbeta + MatRgam'*MatMmp13*MatRbetgam*MatTCpp*MatRbeta;
        MatD(2*PP+1:3*PP, 1:PP) = MatD(2*PP+1:3*PP, 1:PP) + MatRgam'*MatMpm13*MatRgam*MatTCmm + MatRbeta'*MatMpm23*MatRbeta*MatTCpm;
        MatD(2*PP+1:3*PP, PP+1:2*PP) = MatD(2*PP+1:3*PP, PP+1:2*PP) + MatRgam'*MatMpm13*MatRgam*MatTCmp + MatRbeta'*MatMpm23*MatRbeta*MatTCpp - MatRbeta'*MatMpm23*MatRbeta;
5
        
        
        %%%%%% vecB
        vecB=zeros((p^2+2*p)*J,1);
        for j=1:J
                    ind = (j-1)*p*(p+2)+0;
                    vecB(ind+1) = -1/(sqrt(2))*E0*sin(theta_star);
                    vecB(ind+2) = E0*cos(theta_star);
                    vecB(ind+3) = -1/(sqrt(2))*E0*sin(theta_star);
        end

 6       
        MatF=MatA*MatC + MatD;
        
        Coeff_multipole = MatF\vecB;
7
        

        Coeff12 = Coeff_multipole(1:2*PP);%Coeff23 = MatBigRbeta*Coeff_multipole(PP+1:3*PP);
        grad_z = gradient_origin_z(p,Coeff12,N_TO,DL_data,g_data_p,g_data_m,Q,tau,s,alp);
   
        
        
        %%%%%% gradient from far spheres
        sum=0;
        
        MatC23 = MatRTCR_beta;
        MatC23(1:1*PP,1:1*PP) = MatC23(1:1*PP,1:1*PP) - eye(PP);
        Coeff23 = MatC23*Coeff_multipole(PP+1:3*PP);
        
        R=Radius;dist=distance;
        for l=1:p
           for m=-l:l
            j=1;
            ind=(j-1)*p*(p+2)+l^2+l+m;
            sum=sum+Coeff23(ind)*Nablm(l,m,1,0)*CalY(l+1,m,[0,0,-(R+dist/2)]);
           
            j=2;
            ind=(j-1)*p*(p+2)+l^2+l+m;
            sum=sum+Coeff23(ind)*Nablm(l,m,1,0)*CalY(l+1,m,-[0,0,(R+dist/2)]-[2*(R+dist/2)*sin(beta),0,2*(R+dist/2)*cos(beta)]);
           
           end
        end
        grad_z23=sum;
        
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        
        electric_field_data =[electric_field_data, E0*cos(theta_star)-grad_z-grad_z23];
        %coeff_data = [coeff_data, Coeff12(2)];
        %Coeff12t=MatC*Coeff_multipole;
        %Cf=Coeff12t(2)*2;
        [ njn, ii ,11111111 ]
    end
    
    
%%    
figure(10)
plot_data=abs(electric_field_data);
%[mm,ii]=max(yyy1);
%w(ii)
%num_ind_p=1;
C = linspecer(3);
plot(w,plot_data,'-','color','green','linewidth',0.5);
%hold on
%plot(w,plot_data,'-','color',C(3,:),'linewidth',1.5);
hold on

xlabel('Frequency(eV)') % x-axis label
ylabel('Field enhancement') % y-axis label

legend('p=20','exact')
set(gca,'fontsize',17)


axis([1.,3.5,0,1500]);
set(gca,'fontsize',12)

%figure(2)
%plot_data=abs(coeff_data);
%%[mm,ii]=max(yyy1);
%%w(ii)
%C = linspecer(num_ind_p);
%plot(w,plot_data,'o-','color',C(njn,:),'linewidth',1.5);
%hold off

%axis([1.0,3.5,0,4500]);
%set(gca,'fontsize',12)

end
%%
figure(11)
plot_data=abs(electric_field_data);
%[mm,ii]=max(yyy1);
%w(ii)
%num_ind_p=1;
C = linspecer(3);
plot(w,plot_data,'-','color','green','linewidth',0.5);
%hold on
%plot(w,plot_data,'-','color',C(3,:),'linewidth',1.5);
hold on

xlabel('Frequency(eV)') % x-axis label
ylabel('Field enhancement') % y-axis label

legend('p=20','exact')
set(gca,'fontsize',17)


axis([1.,3.5,0,500]);
set(gca,'fontsize',12)

%%
  %save(['MatBdata/' 'Efield_z_dataP' num2str(p) 'N' num2str(N_TO) '.mat'], 'electric_field_data');
     
%%
%load(['MatBdata/' 'Efield_z_dataP' num2str(p) 'N' num2str(N_TO) '.mat'], 'electric_field_data');
%nnn=20;
%NNN=51;
%w=linspace(1,3.5,NNN);  
%w(nnn)
%electric_field_data(nnn)

     
            
 